package com.unis.base.server.dao;

import com.github.pagehelper.Page;
import com.unis.base.common.vo.BaseKcVO;
import com.unis.base.common.vo.DCfxxsjyVO;
import com.unis.base.server.entity.DCfxxsjyDO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.unis.base.common.vo.DCfxxsjyVO;
import com.unis.base.server.entity.DCfxxsjyDO;

import tk.mybatis.mapper.common.Mapper;

import java.util.List;

/**
 *
 * @ClassName: DCfxxsjyDao
 * @Description: DCfxxsjyDao
 * @author huangxing
 * @date 2019年7月22日 下午5:22:22
 *
 * @version v1.0
 */
@Transactional(rollbackFor = Exception.class)
@org.apache.ibatis.annotations.Mapper
@Repository
public interface DCfxxsjyDao extends Mapper<DCfxxsjyDO> {

	/**
	 * 根据信息获取仓房列表
	 * @param dCfxxsjyDO
	 * @return
	 */
	//List<DCfxxsjyDO> getDCfxxxsjyList(DCfxxsjyDO dCfxxsjyDO);

	List<DCfxxsjyDO> getDCfxxxsjy(DCfxxsjyDO dCfxxsjyDO);

	List<DCfxxsjyDO> getDCfxxxsjy_ver2(DCfxxsjyDO dCfxxsjyDO);

	List<DCfxxsjyDO> getChengPinList(DCfxxsjyDO dCfxxsjyDO);

	List<BaseKcVO> getYuanLiangList(DCfxxsjyDO dCfxxsjyDO);

	/**
	 * 根据信息获取唯一仓房
	 * @param dCfxxsjyDO
	 * @return
	 */
	DCfxxsjyDO selectById(DCfxxsjyDO dCfxxsjyDO);

	/**
	 * 获取仓房信息
	 * @param cfbh
	 * @return
	 */
	DCfxxsjyDO getDCfxxxsjyInfo(@Param("cfbh")String cfbh);

	/**
	 * 根据仓房编号获取仓房信息-任何状态
	 * @param cfbh
	 * @return
	 */
	DCfxxsjyDO getWarehouseInfo(@Param("cfbh")String cfbh);

	/**
	 * 更新仓房信息
	 * @param dCfxxsjyDO
	 * @return
	 */
	int update(DCfxxsjyDO dCfxxsjyDO);

	/**
	 * 更新仓房信息
	 * @param dCfxxsjyDO
	 * @return
	 */
	int updateAll(DCfxxsjyDO dCfxxsjyDO);

	/**
	 * 获取最大仓房编号
	 * @return
	 */
	String getMaxCodeById();

	/**
	 * 获取最大设备编号
	 * @return
	 */
	String getMaxById(@Param("prefix")String prefix);

	/**
	 * 添加仓房信息
	 * @return
	 */
	int insert(DCfxxsjyDO dCfxxsjyDO);

	/**
	 * 根据库点代码删除仓房信息列表
	 * @param kddm
	 * @return
	 */
	int deleteList(@Param("kddm")String kddm);

	/**
	 * 根据库点代码获取仓房列表
	 * @param kddm
	 * @return
	 */
	List<DCfxxsjyDO> getWarehouseListByKddm(String kddm,String grainType);

	List<DCfxxsjyVO> selectByEntity(DCfxxsjyVO dCfxxsjyVO);

	/**
	 * 备案主表状态
	 * @param dCfxxsjyVO
	 * @return
	 */
	int updateFiling(DCfxxsjyVO dCfxxsjyVO);

    Page<DCfxxsjyVO> getDCfxxxsjyLists(DCfxxsjyVO dCfxxsjyVO);

	List<DCfxxsjyDO> warehouseListNew(DCfxxsjyDO dCfxxsjyDO);

	List<DCfxxsjyDO> getDCfxxxsjyCbl(DCfxxsjyDO dCfxxsjyDO);

	Integer updateDCfxxsjy(DCfxxsjyVO dCfxxsjyVO);

	Integer deleteByKddmAndCfxh(@Param("kddm") String kddm,@Param("cfxh")String cfxh);

	List<DCfxxsjyVO> getDCfxxxList(DCfxxsjyVO dCfxxsjyVO);

	List<DCfxxsjyVO> selectCfxxsjy(DCfxxsjyVO dCfxxsjyVO);

	List<DCfxxsjyVO> getWarehouseDetail(DCfxxsjyVO dCfxxsjyVO);

    List<String> listGfcfdm(DCfxxsjyDO dCfxxsjyDO);

    DCfxxsjyVO getFirstData(@Param("gfcfdm") String gfcfdm);
}
